'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('core-js/modules/es6.array.for-each');
require('core-js/modules/es6.date.to-json');
require('regenerator-runtime/runtime');
require('core-js/modules/es6.array.is-array');
require('core-js/modules/es6.array.iterator');
require('core-js/modules/es6.string.iterator');
require('core-js/modules/es6.set');
require('core-js/modules/es7.symbol.async-iterator');
require('core-js/modules/es6.symbol');
require('core-js/modules/web.dom.iterable');
require('core-js/modules/es6.array.some');
require('core-js/modules/es6.array.sort');
require('core-js/modules/es6.array.filter');
require('core-js/modules/es6.array.index-of');
require('core-js/modules/es6.array.find');
require('core-js/modules/es6.function.name');
require('core-js/modules/es6.array.map');
var timestring = _interopDefault(require('timestring'));
var isEmpty = _interopDefault(require('is-empty'));
var isVarName = _interopDefault(require('is-var-name'));
var arrayStartsWith = _interopDefault(require('array-starts-with'));

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

var GanttInvalidOp =
/*#__PURE__*/
function (_Error) {
  _inherits(GanttInvalidOp, _Error);

  function GanttInvalidOp(op) {
    _classCallCheck(this, GanttInvalidOp);

    return _possibleConstructorReturn(this, _getPrototypeOf(GanttInvalidOp).call(this, 'invalid operaion: ' + op));
  }

  return GanttInvalidOp;
}(_wrapNativeSuper(Error));

function taskError(taskName, tpl) {
  if (taskName instanceof Task) {
    taskName = taskName.canonicalName;
  }

  taskName = '[' + [].concat(taskName).map(function (it) {
    return "'".concat(it, "'");
  }).join(',') + ']';
  return new Error(tpl(taskName));
}

var Task =
/*#__PURE__*/
function () {
  function Task(name, parent) {
    _classCallCheck(this, Task);

    name && this.name(name);
    this._parent = parent;
    this._onStartCbs = [];
    this._onFinishCbs = [];
    this._subTasks = [];
    this._dependsUpon = [];
    this.$ = this.find;
  }

  _createClass(Task, [{
    key: "name",
    value: function name(arg) {
      if (arg === void 0) {
        return this._name;
      }

      if (!isVarName(arg)) {
        throw new Error('invalid task name ' + arg + ', should use a valid javascript identifier name');
      }

      this._name = arg;
      return this;
    }
  }, {
    key: "bundle",
    value: function bundle(arg) {
      if (arg === void 0) {
        return this._bundle;
      }

      this._bundle = arg;
      return this;
    }
  }, {
    key: "label",
    value: function label(labelArg) {
      if (labelArg === void 0) {
        return this._label || this._name;
      }

      this._label = labelArg;
      return this;
    }
  }, {
    key: "addSubTask",
    value: function addSubTask(arg) {
      var task;

      if (arg instanceof Task) {
        task = arg;
      } else {
        if (typeof arg === 'function') {
          task = new Task('', this);
        } else if (typeof task === 'string') {
          task = new Task(task, this);
        } else {
          throw new Error('task must be a function or string');
        }
      }

      if (this._subTasks.hasOwnProperty(task.name())) {
        throw new Error('task ' + task.name() + ' already exists');
      }

      this._subTasks.push(task); // add at first, then apply function, otherwise sub task can't depends upon
      // some tasks


      if (typeof arg === 'function') {
        arg(task);
      }

      return this;
    }
  }, {
    key: "find",
    value: function find(taskName, updateFunc) {
      return this._findIter(taskName, updateFunc, this);
    }
  }, {
    key: "_findIter",
    value: function _findIter(taskName, updateFunc, root) {
      var taskNames = [].concat(taskName);

      if (taskNames.length === 0) {
        if (typeof updateFunc === 'function') {
          updateFunc.apply(root, [this]);
        }

        return this;
      }

      var idx = this._subTasks.map(function (it) {
        return it._name;
      }).indexOf(taskNames[0]);

      if (idx === -1) {
        return null;
      }

      return this._subTasks[idx].find(taskNames.slice(1), updateFunc, root);
    }
  }, {
    key: "moveSubTask",
    value: function moveSubTask(taskName, before) {
      var subTaskNames = this._subTasks.map(function (it) {
        return it.name();
      });

      var fromIdx = subTaskNames.indexOf(taskName);

      if (fromIdx === -1) {
        throw taskError(taskName, function (n) {
          return "no such task: ".concat(n);
        });
      }

      var toIdx = before ? subTaskNames.indexOf(before) : subTaskNames.length - 1;

      if (toIdx === -1) {
        throw taskError(taskName, function (n) {
          return "no such task: ".concat(n);
        });
      }

      var subTask = this._subTasks.splice(fromIdx, 1)[0];

      this._subTasks.splice(toIdx, 0, subTask);

      return this;
    }
  }, {
    key: "removeSubTask",
    value: function removeSubTask(taskName) {
      var subTasks = this._subTasks.filter(function (it) {
        return it.name() !== taskName;
      });

      if (subTasks.length === this._subTasks.length) {
        throw new Error('no such task: ' + taskName);
      }

      this._subTasks = subTasks;
      return this;
    }
  }, {
    key: "isMyAncestor",
    value: function isMyAncestor(task) {
      if (task instanceof Task) {
        task = task.canonicalName;
      }

      var myCanonicalName = this.canonicalName;

      for (var i = 0; i < task.length; ++i) {
        if (task[i] !== myCanonicalName[i]) {
          return false;
        }
      }

      return true;
    }
  }, {
    key: "getDependsUpon",
    value: function getDependsUpon() {
      if (!this._parent) {
        return [];
      }

      var dependsUpon = this._parent.getDependsUpon().concat(this._dependsUpon) // see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/sort
      // array of array could be sorted
      .map(function (it) {
        return it.canonicalName;
      }).sort();

      if (!dependsUpon.length) {
        return [];
      }

      var pivot = dependsUpon[0];
      var ret = [pivot];
      var i = 0;

      while (i < dependsUpon.length) {
        if (!arrayStartsWith(dependsUpon[i], pivot)) {
          pivot = dependsUpon[i];
          ret.push(pivot);
        }

        ++i;
      }

      var root = this.root;
      return ret.map(function (it) {
        return root.$(it);
      });
    }
  }, {
    key: "doesDependUpon",
    value: function doesDependUpon(task) {
      if (task instanceof Task) {
        task = task.canonicalName;
      }

      return this.getDependsUpon().some(function (it) {
        return arrayStartsWith(task, it.canonicalName);
      });
    }
    /**
     * 设定依赖关系，并可能根据依赖关系调整expectedToStartAt
     * */

  }, {
    key: "dependsUpon",
    value: function dependsUpon() {
      for (var _len = arguments.length, canonicalNames = new Array(_len), _key = 0; _key < _len; _key++) {
        canonicalNames[_key] = arguments[_key];
      }

      if (canonicalNames.length === 0) {
        return this.getDependsUpon();
      }

      canonicalNames = canonicalNames.map(function (it) {
        return it instanceof Task ? it.canonicalName : it;
      });
      var dependsUpon = [];
      var root = this.root;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = canonicalNames[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var n = _step.value;
          var task = root.find(n);

          if (!task) {
            throw taskError(n, function (n) {
              return "no such task: ".concat(n);
            });
          }

          if (this === task) {
            throw taskError(n, function (n) {
              return "can not depends upon self: ".concat(n);
            });
          }

          if (this.isMyAncestor(task)) {
            throw taskError(n, function (n) {
              return "can not depends upon ancestor: ".concat(n);
            });
          }

          if (this.doesDependUpon(task)) {
            throw taskError(n, function (n) {
              return "already depends upon task ".concat(n);
            });
          }

          if (task.doesDependUpon(this)) {
            throw taskError(n, function (n) {
              return "depends upon a task ".concat(n, " which depends on myself (cylic dependent)");
            });
          }

          dependsUpon.push(task);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      this._dependsUpon = this._dependsUpon.concat(dependsUpon);
      return this;
    }
  }, {
    key: "removeDependsUpon",
    value: function removeDependsUpon() {
      for (var _len2 = arguments.length, canonicalNames = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        canonicalNames[_key2] = arguments[_key2];
      }

      canonicalNames = new Set(canonicalNames.map(function (it) {
        return it instanceof Task ? it.canonicalName : it;
      }).map(function (it) {
        return it.join('.');
      }));
      this._dependsUpon = this._dependsUpon.filter(function (it) {
        return !canonicalNames.has(it.canonicalName.join('.'));
      });
      return this;
    }
    /**
     * when this task is expected to start at.
     * it has nothing to do with the
     * actual progressing
     * */

  }, {
    key: "start",
    value: function start(args) {
      return this.startAt(new Date(), args);
    }
  }, {
    key: "startAt",
    value: function startAt(t) {
      if (this.isLeaf) {
        if (t === void 0) {
          return this._startAt;
        }

        this._startAt = new Date(t).getTime();
      } else {
        if (t === void 0) {
          var startedTasks = this._subTasks.filter(function (it) {
            return it.startAt() !== void 0;
          });

          if (!startedTasks.length) {
            return;
          }

          return Math.min.apply(null, startedTasks.map(function (it) {
            return it.startAt();
          }));
        }

        throw Error('non-leaf task can not set start at');
      }

      return this;
    }
  }, {
    key: "startArg",
    value: function startArg(arg) {
      if (arg === void 0) {
        return this._startArg;
      }

      this._startArg = typeof arg === 'string' ? timestring(arg, 'ms') : arg;
      return this;
    }
  }, {
    key: "expectedTimeSpan",
    value: function expectedTimeSpan(arg) {
      if (this.isLeaf) {
        if (arg === void 0) {
          return this._expectedTimeSpan;
        }

        this._expectedTimeSpan = typeof arg === 'string' ? timestring(arg, 'ms') : arg;
      } else {
        if (arg === void 0) {
          return this.expectedToFinishAt - this.expectedToStartAt;
        }

        throw new Error('non-leaf task can not set expected time span');
      }

      return this;
    }
  }, {
    key: "finish",
    value: function finish(args) {
      return this.finishAt(new Date(), args);
    }
  }, {
    key: "finishAt",
    value: function finishAt(t) {
      if (this.isLeaf) {
        if (t === void 0) {
          return this._finishAt;
        }

        this._finishAt = new Date(t).getTime();
      } else {
        if (t === void 0) {
          var finishedTasks = this._subTasks.filter(function (it) {
            return it.finishAt() !== void 0;
          });

          if (!finishedTasks.length) {
            return;
          }

          return Math.max.apply(null, finishedTasks.map(function (it) {
            return it.finishAt();
          }));
        }

        throw Error('non-leaf task can not set finish at');
      }

      return this;
    }
  }, {
    key: "description",
    value: function description(arg) {
      if (arg === void 0) {
        return this._description;
      }

      this._description = arg;
      return this;
    }
  }, {
    key: "finishArg",
    value: function finishArg(arg) {
      if (arg === void 0) {
        return this._finishArg;
      }

      this._finishArg = arg;
      return this;
    }
  }, {
    key: "ops",
    value: function ops(arg) {
      if (arg === void 0) {
        return this._ops || (this.isLeaf ? [Task.OP_START, Task.OP_FINISH] : []);
      }

      if (!this.isLeaf && !isEmpty(arg)) {
        throw new Error('non-leaf tasks can\'t set ops');
      }

      if (!Array.isArray(arg) || arg.length > 2 || !arg.every(function (it) {
        return it === Task.OP_START || it === Task.OP_FINISH;
      })) {
        throw new Error('ops must be an array containing op ' + Task.OP_START + ' or ' + Task.OP_FINISH);
      }

      this._ops = arg;
      return this;
    }
  }, {
    key: "perform",
    value: function () {
      var _perform = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(action, arg) {
        var _Task$OP_START$Task$O;

        var _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, cb, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, _cb;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this.isLeaf) {
                  _context.next = 2;
                  break;
                }

                throw new Error('you can\'t perform operation upon non-leaf task');

              case 2:
                if (!(this.ops().indexOf(action) === -1)) {
                  _context.next = 4;
                  break;
                }

                throw new GanttInvalidOp(action);

              case 4:
                action = (_Task$OP_START$Task$O = {}, _defineProperty(_Task$OP_START$Task$O, Task.OP_START, 'start'), _defineProperty(_Task$OP_START$Task$O, Task.OP_FINISH, 'finish'), _Task$OP_START$Task$O)[action];
                this[action](arg);

                if (!(action === 'start')) {
                  _context.next = 35;
                  break;
                }

                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context.prev = 10;
                _iterator2 = this._onStartCbs[Symbol.iterator]();

              case 12:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context.next = 19;
                  break;
                }

                cb = _step2.value;
                _context.next = 16;
                return cb.call(this);

              case 16:
                _iteratorNormalCompletion2 = true;
                _context.next = 12;
                break;

              case 19:
                _context.next = 25;
                break;

              case 21:
                _context.prev = 21;
                _context.t0 = _context["catch"](10);
                _didIteratorError2 = true;
                _iteratorError2 = _context.t0;

              case 25:
                _context.prev = 25;
                _context.prev = 26;

                if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                  _iterator2.return();
                }

              case 28:
                _context.prev = 28;

                if (!_didIteratorError2) {
                  _context.next = 31;
                  break;
                }

                throw _iteratorError2;

              case 31:
                return _context.finish(28);

              case 32:
                return _context.finish(25);

              case 33:
                _context.next = 62;
                break;

              case 35:
                if (!(action === 'finish')) {
                  _context.next = 62;
                  break;
                }

                _iteratorNormalCompletion3 = true;
                _didIteratorError3 = false;
                _iteratorError3 = undefined;
                _context.prev = 39;
                _iterator3 = this._onFinishCbs[Symbol.iterator]();

              case 41:
                if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                  _context.next = 48;
                  break;
                }

                _cb = _step3.value;
                _context.next = 45;
                return _cb.call(this);

              case 45:
                _iteratorNormalCompletion3 = true;
                _context.next = 41;
                break;

              case 48:
                _context.next = 54;
                break;

              case 50:
                _context.prev = 50;
                _context.t1 = _context["catch"](39);
                _didIteratorError3 = true;
                _iteratorError3 = _context.t1;

              case 54:
                _context.prev = 54;
                _context.prev = 55;

                if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
                  _iterator3.return();
                }

              case 57:
                _context.prev = 57;

                if (!_didIteratorError3) {
                  _context.next = 60;
                  break;
                }

                throw _iteratorError3;

              case 60:
                return _context.finish(57);

              case 61:
                return _context.finish(54);

              case 62:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[10, 21, 25, 33], [26,, 28, 32], [39, 50, 54, 62], [55,, 57, 61]]);
      }));

      return function perform(_x, _x2) {
        return _perform.apply(this, arguments);
      };
    }()
  }, {
    key: "onStart",
    value: function onStart(arg) {
      this._onStartCbs.push(arg);

      return this;
    }
  }, {
    key: "onFinish",
    value: function onFinish(arg) {
      this._onFinishCbs.push(arg);

      return this;
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        name: this.name(),
        bundle: this.bundle(),
        depth: this.depth,
        isLeaf: this.isLeaf,
        canonicalName: this.canonicalName,
        label: this.label(),
        subTasks: this.subTasks.map(function (it) {
          return it.toJSON();
        }),
        dependsUpon: this.getDependsUpon().map(function (it) {
          return it.canonicalName;
        }),
        expectedToStartAt: this.expectedToStartAt,
        startAt: this.startAt(),
        startArg: this.startArg(),
        expectedTimeSpan: this.expectedTimeSpan(),
        finishAt: this.finishAt(),
        finishArg: this.finishArg(),
        expectedToFinishAt: this.expectedToFinishAt,
        description: this.description(),
        ops: this.ops(),
        nextOp: this.nextOp
      };
    }
  }, {
    key: "fromJSON",
    value: function fromJSON(arg) {
      var _this = this;

      var _arr = ['name', 'label', 'startAt', 'startArg', 'expectedTimeSpan', 'finishAt', 'finishArg', 'description', 'bundle', 'ops'];

      for (var _i = 0; _i < _arr.length; _i++) {
        var k = _arr[_i];
        arg[k] && this[k](arg[k]);
      }

      arg.subTasks && arg.subTasks.length && arg.subTasks.forEach(function (it) {
        return _this.addSubTask(function (task) {
          return task.fromJSON(it);
        });
      });
      arg.dependsUpon && arg.dependsUpon.length && this.dependsUpon(arg.dependsUpon);
      return this;
    }
  }, {
    key: "isLeaf",
    get: function get() {
      return isEmpty(this._subTasks);
    }
  }, {
    key: "root",
    get: function get() {
      return this._parent ? this._parent.root : this;
    }
  }, {
    key: "canonicalName",
    get: function get() {
      return (this._parent ? this._parent.canonicalName : []).concat(this._name);
    }
  }, {
    key: "subTasks",
    get: function get() {
      return this._subTasks;
    }
  }, {
    key: "expectedToStartAt",
    get: function get() {
      return Math.max.apply(null, this.isLeaf ? this.getDependsUpon().map(function (it) {
        return it.expectedToFinishAt;
      }).concat(0) // if not leaf, only ask sub tasks, since they will depends upon my dependents
      // check dependsUpon
      : this.subTasks.map(function (it) {
        return it.expectedToStartAt;
      }));
    }
  }, {
    key: "expectedToFinishAt",
    get: function get() {
      if (this.isLeaf) {
        return this._finishAt || (this.startAt() || this.expectedToStartAt) + this._expectedTimeSpan;
      }

      return Math.max.apply(null, this._subTasks.map(function (it) {
        return it.expectedToFinishAt;
      }));
    }
  }, {
    key: "depth",
    get: function get() {
      if (this.isLeaf) {
        return 1;
      }

      return Math.max.apply(Math, _toConsumableArray(this._subTasks.map(function (it) {
        return it.depth;
      }))) + 1;
    }
  }, {
    key: "nextOp",
    get: function get() {
      return (this.ops() || [])[0];
    }
  }]);

  return Task;
}();

Task.OP_START = 'start';
Task.OP_FINISH = 'finish';

var Project =
/*#__PURE__*/
function (_Task) {
  _inherits(Project, _Task);

  function Project() {
    _classCallCheck(this, Project);

    return _possibleConstructorReturn(this, _getPrototypeOf(Project).apply(this, arguments));
  }

  _createClass(Project, [{
    key: "canonicalName",
    get: function get() {
      return [];
    }
  }]);

  return Project;
}(Task);

function project(name) {
  return new Project(name);
}

exports.project = project;
exports.Project = Project;
exports.Task = Task;
